# -*- coding: utf-8 -*-

###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# EolePack : script de génération de paquets deb
#  
# 
#       
###########################################################################
"""
fichier de configuration et récupération de données 
"""

import sys
from os.path import isfile
from ConfigParser import ConfigParser
from eolepack.tools import clean_str


class Config:
    "parser de fichier de configuration"
    def __init__(self, maincfgfile):
        """
        maincfgfile: configuration principale (eolepack.conf)
        """
        if not isfile(maincfgfile):
            raise NameError, "Fichier %s introuvable" % maincfgfile
        self.main = ConfigParser()
        self.main.read(maincfgfile)
        if not self.main.has_section('GLOBAL'):
            # FIXME
            print "section GLOBAL non trouvée !"
            sys.exit()
        
    def get_distributions(self):
        """
        distributions disponibles (sections du main sans GLOBAL
        """
        dist = self.main.sections()
        dist.remove('GLOBAL')
        return dist


    def get_main_value(self, section, option):
        """
        récupération d'une option de configuration principale
        dans une section particulière        
        """
        if not self.main.has_section(section):
            print "section %s non trouvée !"%section
            sys.exit()
        return clean_str(self.main.get(section, option))


