# -*- coding: utf-8 -*-
###########################################################################
#
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
# eole@ac-dijon.fr
#
###########################################################################
"""
point d'entrée des traitements

"""

from eolepack.cfgparser import Config
from eolepack.configserver import *
from eolepack.tools import export_env_vars



def read_eolepack_conf_file(fname=EOLEPACK_FILE):
    """lecture du fichier general applicatif
    """
    packconf = Config(cfgfile=fname, sections=['GLOBAL', 'eole-2.0'])
    packvars = list(packconf.parse_all_vars())
    packvarnames = [name for name, value in packvars]
    # variables obligatoires
    requiered_vars = [var.upper() for var in EOLEPACK_VARS]
    for var in requiered_vars:
        if var not in packvarnames:
            raise NameError, "la variable %s est manquante" % var
    return packvars

def read_compil_conf_file(fname):
    """lecture du fichier de conf propre à chaque build
    fname : nom long du fichier
    """
    packconf = Config(cfgfile=fname, sections=[])
    packvars = list(packconf.parse_all_vars())
    packvarnames = [name for name, value in packvars]
    # variables obligatoires
    requiered_vars = [var.upper() for var in COMPIL_VARS]
    for var in requiered_vars:
        if var not in packvarnames:
            raise NameError, "la variable %s est manquante" % var
    return packvars


def read_vars(compil_fname):
    """collecte toutes les variables des fichiers de conf
    et renvoie un dictionnaire de variables
    """
    configvars =  dict(read_compil_conf_file(compil_fname))
    configvars.update(dict(read_eolepack_conf_file(fname=EOLEPACK_FILE)))
    return configvars

def export_vars(vars=EXPORT_VARS):
    """exporte certaines variables dans env
    """
    pass


