#!/usr/bin/env python
# -*- coding: utf-8 -*-

###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# Serveur xmlrpc pour la compilation des paquets EoleNg
#
###########################################################################

from twisted.web import xmlrpc, server
from twisted.python import log
from eolepack.pack import pack
from eolepack.delete import delete_package
import time, sys
from glob import glob
from eolepack.configserver import COMPIL_PATH
from eolepack import ldapauth

class ServerXMLRPC(xmlrpc.XMLRPC):

    def xmlrpc_pack(self, paquet, version, distribution, user, passwd,
                    tags=None, branches=None, revision=None, epoch=None, changelog=None):
        # serialisation de la chaine None pour le xmlrpc
        for var in ['tags','branches','revision','epoch','changelog']:
            if eval(var) == 'None':
                exec(var+"=None")

        """Return all passed args."""
        return pack(paquet, version, distribution, user, passwd, tags, branches, revision, epoch, changelog)

    def xmlrpc_delete_package(self, paquet, version, dist_eole):
        return delete_package(paquet, version, dist_eole)

    def xmlrpc_get_rapportfile(self, name, version):
        rapportfile = glob('%s/rapport_%s.txt' % (COMPIL_PATH, name))
        if len(rapportfile) != 1:
            return ""
        else:
            return file(rapportfile[0]).read()

    def xmlrpc_run_authentif(self, user, pwd):
        return ldapauth.authenticate(user, pwd)

if __name__ == '__main__':
    from twisted.internet import reactor
    log.startLogging(sys.stdout)
    print
    print time.ctime()
    print "démarrage du serveur de compilation"
    print
    r = ServerXMLRPC()
    reactor.listenTCP(7081, server.Site(r))
    reactor.run()
